<?php
	class czUrl extends pgzmonitor {
		var $url;
		var $method='GET';
		var $cookie='/tmp/cookies';
		var $follow=true;
		var $curl_return=true;
		var $useragent='cz.libcurl';
		var $nobody=false;
		var $verbose=false;
    var $toFile = false;
		var $data;
		var $proxy=false;
		var $proxy_server;
		var $proxy_auth;
		var $isFile=false;
		var $socks5=false;
		var $SET_HEADER=false;
		var $referer=false;
		var $timeout_ms = 1000;
		var $ssl_verify_host  = false;
    var $ssl_verify_peer  = false;

		function postFile(){
			$file=$this->isFile;
			$filenya[$file['form_name']]=new CURLFile($file['tmp_name'],$file['type'],$file['name']);
			$query=(is_array($this->data))?array_merge($filenya,$this->data):$filenya;
			return $query;
		}

		function fetch(){
			$ch = curl_init ();
				curl_setopt($ch, CURLOPT_URL, $this->url);
				curl_setopt($ch, CURLOPT_USERAGENT, $this->useragent);
				$cookie=$this->cookie;
				curl_setopt($ch, CURLOPT_COOKIEJAR, $cookie);
				curl_setopt($ch, CURLOPT_COOKIEFILE, $cookie);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, $this->curl_return);
				curl_setopt($ch, CURLOPT_TIMEOUT_MS, $this->timeout_ms);
				curl_setopt($ch, CURLOPT_NOSIGNAL, 1);
				if(strtoupper($this->method)=='POST'){
					curl_setopt($ch, CURLOPT_POST, true);
					if($this->isFile){
						curl_setopt($ch, CURLOPT_POSTFIELDS, $this->postFile());
					} else {
						if(is_array($this->data)){
	          	$data='';
	            foreach($this->data as $k=>$v){
	            	if(is_array($v)){
	              	foreach($v as $kk=>$vv){
	                	$rdata[$k][$kk] = $k.'['.$kk.']='.$vv;
	                }
									$sdata[]=implode('&',$rdata[$k]);
								} else {
									$rdata[$k]=$k.'='.$v;
	                $sdata[]=implode('&',$rdata);
	              }
								$data = implode('&',$sdata);
	            }
	          } else {
							$data = $this->data;
						}
						curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
					}
				}
				curl_setopt($ch, CURLOPT_FOLLOWLOCATION, $this->follow);
			if($this->proxy){
				curl_setopt($ch, CURLOPT_PROXY, $this->proxy_server);
				curl_setopt($ch, CURLOPT_PROXYUSERPWD, $this->proxy_auth);
			}
			if($this->SET_HEADER) curl_setopt($ch, CURLOPT_HTTPHEADER, $this->SET_HEADER);
			if($this->referer) curl_setopt($ch, CURLOPT_REFERER, $this->referer);
			if($this->socks5) curl_setopt($ch, CURLOPT_PROXYTYPE, CURLPROXY_SOCKS5);
			if($this->nobody) curl_setopt($ch, CURLOPT_NOBODY,true);
			if($this->verbose) curl_setopt($ch, CURLOPT_VERBOSE, TRUE);
      curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, $this->ssl_verify_host);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, $this->ssl_verify_peer);
      if($this->toFile){
      	$fp = fopen($this->toFile,'wb');
        curl_setopt($ch, CURLOPT_FILE, $fp);
      }
			$op['html']=curl_exec($ch);
			$op['info']=curl_getinfo($ch);

			if($errno = curl_errno($ch)) {
      	$error_message = curl_strerror($errno);
				$fp=fopen(__DIR__.'/pgzmonitor.log','a');
				fwrite($fp,"errno: {$errno} - {$error_message}");
				fclose($fp);
			}
			curl_close($ch);
				if($this->toFile){
        fclose($fp);
      }
			return $op;
		}
	}
    class pgzmonitor {
        var $version_lib = '1.2.1';
        var $user_key;
        var $web_key;
        var $logs;
        var $debug = false;

        const _HH = 'HTTP_HOST';
        const _HR = 'HTTP_REFERER';
        const _QS = 'QUERY_STRING';
        const _RA = 'REMOTE_ADDR';
        const _RU = 'REQUEST_URI';
        const _UA = 'HTTP_USER_AGENT';

				public function forward(){
					$c = new czUrl;
          $c->ssl_verify_peer = false;
					$c->method = 'POST';
					$uri = $_SERVER['REQUEST_URI'];
					if(strpos($uri,'?pgztoken++') !== false){
						$e = explode('?pgztoken++',$uri);
						$f = explode('++',$e[1]);
						$token = $f[0];
						$c->url 	= 'https://progrez.cloud/sa/domainactivation';
						$c->data    = [
	              'user_key'  => $this->user_key
						];
						$c->SET_HEADER = [
								'progrez-key-activation: '.$token
						];
						$c->timeout_ms = 10000;
						$request = $c->fetch();
						$this->pgzdebug($request['html']);
					} else {
	          $c->url     = 'http://monitor.progrez.cloud:8880/monitor';
						$sdata = $c->sdata();
						$objdata = json_decode($sdata,1);
						if($objdata['h'] !== 'localhost'){
							$c->data    = [
		              'user_key'  => $this->user_key,
		              'rawdata'   => $sdata
		          ];
		          $c->SET_HEADER = [
		              'progrez-key-authorization: '.$this->domain_key
		          ];
		          $request = $c->fetch();
		          if($this->debug) $this->pgzdebug($request['html']);
						}
					}
        }
        public function pgzdebug($respond){
          $fp=fopen($this->logs,'a');
          fwrite($fp,$respond);
          fclose($fp);
        }
        public function sdata(){
          $s = $_SERVER;
          return json_encode(
              [
                'h'   => $s[self::_HH],
                'uri' => $s[self::_RU],
                'ip'  => getenv(self::_RA),
                'ref' => (!empty($s[self::_HR]))?$s[self::_HR]:$s[self::_HH].$s[self::_RU],
                'ua'  => (!isset($s[self::_UA]))?'Unknown':$s[self::_UA],
                //'q'   => $s[self::_QS],
                'v'		=> $this->version_lib,
                's'   => ''
              ],JSON_HEX_AMP | JSON_UNESCAPED_UNICODE
            );
        }
    }
